package it.unitn.ing.swing.plaf.macos;

/**
  * From macnative package to swing/plaf/macos - mjh 09.10.00
  **/
  
import  com.apple.mrj.jdirect.*;					// mjh 02.14.99


/**
 * <CODE>MacRegionStruct</CODE> is a class which holds a reference to the C struct <CODE>MacRegion</CODE> defined in <CODE>Quickdraw.h</CODE><BR><BR>
 * This class contains a get and set method for each field in <CODE>MacRegion</CODE>.<BR><BR>
 * Using JDirect 2.0, a <CODE>MacRegionStruct</CODE> can be passed to a native toolbox function
 * that expects a Handle to a <CODE>MacRegion</CODE> by using the <CODE>getHandle()</CODE> method. 
 */
public class MacRegionStruct extends HandleStruct {

	/**
	 * Constructs a <CODE>MacRegionStruct</CODE> given a Handle to a MacOS toolbox <CODE>MacRegion</CODE>
	 */
	public MacRegionStruct(int handle) {
		super(handle);
	}

	/**
	 * in C: <CODE>unsigned short rgnSize</CODE>
	 * @return field <CODE>rgnSize</CODE> of <CODE>struct MacRegion</CODE>
	 */
	public final short getRgnSize() {
		return getShortAt(0);
	}

	/**
	 * in C: <CODE>unsigned short rgnSize</CODE>
	 * @param rgnSize sets field <CODE>rgnSize</CODE> of <CODE>struct MacRegion</CODE>
	 */
	public final void setRgnSize(short rgnSize) {
		setShortAt(0, rgnSize);
	}

	/**
	 * in C: <CODE>Rect rgnBBox</CODE>
	 * @return field <CODE>rgnBBox</CODE> of <CODE>struct MacRegion</CODE>
	 */
	public final RectStruct getRgnBBox() {
		return new RectStruct (this, 2);
	}

	/**
	 * in C: <CODE>Rect rgnBBox</CODE>
	 * @param rgnBBox sets field <CODE>rgnBBox</CODE> of <CODE>struct MacRegion</CODE>
	 */
	public final void setRgnBBox(RectStruct rgnBBox) {
		setStructAt(2, rgnBBox);
	}

	/**
	 * Size of <CODE>struct MacRegion</CODE> in bytes
	 */
	public final static int sizeOfMacRegion = 10;

	public int getSize() {
		return sizeOfMacRegion;
	}
}
