package it.unitn.ing.swing.plaf.macos;

/**
  * From macnative package to swing/plaf/macos - mjh 09.10.00
  **/

import  com.apple.mrj.jdirect.Struct;
import  com.apple.mrj.jdirect.ByteArrayStruct;

/**
 * <CODE>ProcessSerialNumberStruct</CODE> is a class which mimics the C struct <CODE>ProcessSerialNumber</CODE> defined in <CODE>Processes.h</CODE><BR><BR>
 * This class contains a get and set method for each field in <CODE>ProcessSerialNumber</CODE>.<BR><BR>
 * Using JDirect 2.0, a <CODE>ProcessSerialNumberStruct</CODE> can be passed to a native toolbox function
 * that expects a pointer to a <CODE>ProcessSerialNumber</CODE> by using the <CODE>getByteArray()</CODE> method. 
 */
public class ProcessSerialNumberStruct extends ByteArrayStruct {

	/**
	 * Constructs an uninitialized <CODE>ProcessSerialNumberStruct</CODE>
	 */
	public ProcessSerialNumberStruct() {
		super(sizeOfProcessSerialNumber);
	}

	/**
	 * Constructs a <CODE>ProcessSerialNumberStruct</CODE> and initializes it with the data in another <CODE>Struct</CODE>. 
	 * Useful when a C struct <CODE>ProcessSerialNumber</CODE> is embedded in another C struct and you want to
	 * copy it out. 
	 * @param src the <CODE>Struct</CODE> containing the data to be copied
	 * @param offsetInSrc the offest in of the data in <CODE>src</CODE>
	 */
	public ProcessSerialNumberStruct(Struct src, int offsetInSrc) {
		super(sizeOfProcessSerialNumber);
		byte[] bytes = src.getBytesAt(offsetInSrc, sizeOfProcessSerialNumber);
		this.setBytesAt(0, bytes);
	}

	/**
	 * Used only by subclasses of <CODE>ProcessSerialNumberStruct</CODE>
	 */
	protected ProcessSerialNumberStruct(int size) {
		super(size);
	}

	/**
	 * in C: <CODE>unsigned long highLongOfPSN</CODE>
	 * @return field <CODE>highLongOfPSN</CODE> of <CODE>struct ProcessSerialNumber</CODE>
	 */
	public final int getHighLongOfPSN() {
		return getIntAt(0);
	}

	/**
	 * in C: <CODE>unsigned long highLongOfPSN</CODE>
	 * @param highLongOfPSN sets field <CODE>highLongOfPSN</CODE> of <CODE>struct ProcessSerialNumber</CODE>
	 */
	public final void setHighLongOfPSN(int highLongOfPSN) {
		setIntAt(0, highLongOfPSN);
	}

	/**
	 * in C: <CODE>unsigned long lowLongOfPSN</CODE>
	 * @return field <CODE>lowLongOfPSN</CODE> of <CODE>struct ProcessSerialNumber</CODE>
	 */
	public final int getLowLongOfPSN() {
		return getIntAt(4);
	}

	/**
	 * in C: <CODE>unsigned long lowLongOfPSN</CODE>
	 * @param lowLongOfPSN sets field <CODE>lowLongOfPSN</CODE> of <CODE>struct ProcessSerialNumber</CODE>
	 */
	public final void setLowLongOfPSN(int lowLongOfPSN) {
		setIntAt(4, lowLongOfPSN);
	}

	/**
	 * Size of <CODE>struct ProcessSerialNumber</CODE> in bytes
	 */
	public final static int sizeOfProcessSerialNumber = 8;

	public long getValue() {
		return getLongAt(0);
	}
}
