package it.unitn.ing.swing.plaf.macos;

/**
  * From macnative package to swing/plaf/macos - mjh 09.10.00
  **/
  
import  com.apple.mrj.jdirect.*;				// mjh 02.14.99

/**
 * <CODE>RGBColorStruct</CODE> is a class which mimics the C struct <CODE>RGBColor</CODE> defined in <CODE>Quickdraw.h</CODE><BR><BR>
 * This class contains a get and set method for each field in <CODE>RGBColor</CODE>.<BR><BR>
 * Using JDirect 2.0, a <CODE>RGBColorStruct</CODE> can be passed to a native toolbox function
 * that expects a pointer to a <CODE>RGBColor</CODE> by using the <CODE>getByteArray()</CODE> method. 
 */
public class RGBColorStruct extends ByteArrayStruct {

	/**
	 * Constructs an uninitialized <CODE>RGBColorStruct</CODE>
	 */
	public RGBColorStruct() {
		super(sizeOfRGBColor);
	}

	/**
	 * Constructs a <CODE>RGBColorStruct</CODE> and initializes it with the data in another <CODE>Struct</CODE>. 
	 * Useful when a C struct <CODE>RGBColor</CODE> is embedded in another C struct and you want to
	 * copy it out. 
	 * @param src the <CODE>Struct</CODE> containing the data to be copied
	 * @param offsetInSrc the offest in of the data in <CODE>src</CODE>
	 */
	public RGBColorStruct(Struct src, int offsetInSrc) {
		super(sizeOfRGBColor);
		byte[] bytes = src.getBytesAt(offsetInSrc, sizeOfRGBColor);
		this.setBytesAt(0, bytes);
	}

	/**
	 * Used only by subclasses of <CODE>RGBColorStruct</CODE>
	 */
	protected RGBColorStruct(int size) {
		super(size);
	}

	/**
	 * in C: <CODE>unsigned short red</CODE>
	 * @return field <CODE>red</CODE> of <CODE>struct RGBColor</CODE>
	 */
	public final short getRed() {
		return getShortAt(0);
	}

	/**
	 * in C: <CODE>unsigned short red</CODE>
	 * @param red sets field <CODE>red</CODE> of <CODE>struct RGBColor</CODE>
	 */
	public final void setRed(short red) {
		setShortAt(0, red);
	}

	/**
	 * in C: <CODE>unsigned short green</CODE>
	 * @return field <CODE>green</CODE> of <CODE>struct RGBColor</CODE>
	 */
	public final short getGreen() {
		return getShortAt(2);
	}

	/**
	 * in C: <CODE>unsigned short green</CODE>
	 * @param green sets field <CODE>green</CODE> of <CODE>struct RGBColor</CODE>
	 */
	public final void setGreen(short green) {
		setShortAt(2, green);
	}

	/**
	 * in C: <CODE>unsigned short blue</CODE>
	 * @return field <CODE>blue</CODE> of <CODE>struct RGBColor</CODE>
	 */
	public final short getBlue() {
		return getShortAt(4);
	}

	/**
	 * in C: <CODE>unsigned short blue</CODE>
	 * @param blue sets field <CODE>blue</CODE> of <CODE>struct RGBColor</CODE>
	 */
	public final void setBlue(short blue) {
		setShortAt(4, blue);
	}

	/**
	 * Size of <CODE>struct RGBColor</CODE> in bytes
	 */
	public final static int sizeOfRGBColor = 6;
}
